<script>
import ContributionStatisticsByYears from "./ContributionStatisticsByYears";
import CommentStatisticsByYears from "./CommentStatisticsByYears";

export default {
  name: "ContributionStatistics",
  components: {
    ContributionStatisticsByYears,
    CommentStatisticsByYears
  },
  data () {
    return {
      showContributions: true,
      showComments: false
    };
  },
  computed: {
    contributionsCount () {
      return this.$store.getters.contributionsCount;
    },
    commentsCount () {
      return this.$store.getters.commentsCount;
    }
  },
  created () {
    this.$store.dispatch("contributions");
    this.$store.dispatch("comments");
  },
  methods: {
    setDisplayType (type) {
      Object.values(this.$refs).forEach(ref => ref.setDisplayType(type));
    },
    switchContributionsComments () {
      this.showContributions ^= 1;
      this.showComments ^= 1;
    }
  }
};
</script>

<template>
  <div class="ContributionStatistics">
    <div class="switcher">
      <div
        :class="{underline: showContributions}"
        role="button"
        tabindex="0"
        @click="switchContributionsComments"
        @keyup.enter="switchContributionsComments"
      >
        {{ $t("components.ContributionStatistics.displayToggles.contributions") }}
      </div>

      <div
        :class="{underline: showComments}"
        role="button"
        tabindex="0"
        @click="switchContributionsComments"
        @keyup.enter="switchContributionsComments"
      >
        {{ $t("components.ContributionStatistics.displayToggles.comments") }}
      </div>
    </div>

    <div class="totalNumber">
      <p>
        Gesamt: {{ showContributions ? contributionsCount : commentsCount }}
      </p>
    </div>

    <div class="widgetContent">
      <ContributionStatisticsByYears
        v-show="showContributions"
        ref="ContributionStatisticsByYears"
      />

      <CommentStatisticsByYears
        v-show="showComments"
        ref="CommentStatisticsByYears"
      />
    </div>
  </div>
</template>

<style lang="scss">
@import "../../../scss/_global.scss";

div.ContributionStatistics {
  flex: 1;
  display: flex;
  flex-direction: column;

  & > div {
    display: flex;

    &.switcher {
      flex-direction: row;
      justify-content: center;
      text-align: center;

      div.underline {
        margin-left: 0.75rem;
        margin-right: 0.75rem;
        margin-top: 1rem;
        margin-bottom: 1rem;
        cursor: pointer;
        color: $color_primary_1;
        @extend %fontdefinition_subline;
        text-decoration: underline;
      }

      div {
        margin-left: 0.75rem;
        margin-right: 0.75rem;
        margin-top: 1rem;
        margin-bottom: 1rem;
        cursor: pointer;
        color: $color_primary_1;
        @extend %fontdefinition_subline;
        font-weight: normal;
      }
    }

    &.totalNumber {
      flex-direction: column;
      justify-content: center;
      text-align: center;
      height: 36px;
      margin-bottom: 15px;

      p {
        @extend %fontdefinition_headline_2;
        margin: 0;
      }
    }

    &.widgetContent {
      flex-direction: column;
      flex: 1;

      & > section {
        flex: 1;

        h3 {
          @extend %fontdefinition_subline;
        }

        & > div {
          // Do NOT remove or alter that style - greater values or even display: flex will
          // cause the chart to "run away" in height - trigger loop between resize and creation.
          height: 95%;
          min-height: 100px;
        }
      }
    }
  }

  hr {
    width: 75%;
    border-top: solid 1px $color_primary_1;
    margin: 15px auto;
  }

  table {
    td, th {
      border: solid 1px $color_secondary_3;
      padding: 0 5px;
      text-align: center
    }

    th:nth-child(1), td:nth-child(1) {
      text-align: left;
    }
  }

  div.a.switcher {
    text-decoration-line: underline;
  }
}
</style>
